; example of using some weather station data in a hash

url = 'http://www.rap.ucar.edu/weather/surface/stations.txt'
neturl = obj_new('IDLnetUrl')

data = neturl->get(url=url, /string_array)
data = [data, '']   ; add extra blank line to make processing easier

elevations = hash()

blanks = where(data eq '', count)
for b = 0L, count - 1L do begin
  line_number = blanks[b] + 3L   ; skip blank line, name of state, and header
  
  while (line_number lt (n_elements(data) - 1L) && line_number lt blanks[b + 1]) do begin
    line = data[line_number]
    station = strmid(line, 26, 3)
    elevation = strmid(line, 55, 4)
    
    if (strtrim(station, 2) ne '' && strtrim(elevation, 2) ne '') then begin
      help, station, elevation
      elevations[station] = long(elevation)
    endif
    
    line_number++
  endwhile
endfor

end
